#ifndef CHEAPTREE
#define CHEAPTREE
#include "iostream"

template <class Item>
class CHeapTree
{
  protected:
  
  Item* arrayOfItems;
  int   numberOfItems;
  
  
	public:
	
	CHeapTree(int Size)
	{
		numberOfItems = Size;
	  arrayOfItems  = new Item[numberOfItems];
  };
  
  CHeapTree(const CHeapTree<Item> &OtherTree)
  {
  	numberOfItems = OtherTree.numberOfItems;
    arrayOfItems  = new Item[numberOfItems];
	  for (int i = 0; i < numberOfItems; ++i)
  	{
    	arrayOfItems[i] = OtherTree.arrayOfItems[i];
	  }
  };
  
  void setItem(int n, Item value)
  {
  	arrayOfItems[n]=value;
  };
  
  Item getItem(int n) const
  {
    return arrayOfItems[n];
  };
  
	void shiftDown(int root, int bottom)
	{
  	int done, maxChild, temp;

	  done = 0;
  	while ((root*2 <= bottom) && (!done))
	  {
  	  if (root*2 == bottom)
    	  maxChild = root * 2;
	    else if (arrayOfItems[root * 2] > arrayOfItems[root * 2 + 1])
  	    maxChild = root * 2;
    	else
      	maxChild = root * 2 + 1;

	    if (arrayOfItems[root] < arrayOfItems[maxChild])
  	  {
    	  temp = arrayOfItems[root];
      	arrayOfItems[root] = arrayOfItems[maxChild];
	      arrayOfItems[maxChild] = temp;
  	    root = maxChild;
    	}
	    else
  	    done = 1;
	  }
	};

	void sortIt()
	{
  	int i, temp;

	  for (i = (numberOfItems / 2)-1; i >= 0; i--)
  	  shiftDown(i, numberOfItems);

	  for (i = numberOfItems-1; i >= 1; i--)
  	{
    	temp = arrayOfItems[0];
	    arrayOfItems[0] = arrayOfItems[i];
  	  arrayOfItems[i] = temp;
    	shiftDown(0, i-1);
	  }
	};
	
	friend std::ofstream& operator<<(std::ofstream& s, const Item& myTree)
	{
	  for (i=0; i < myTree.numberOfItems-1; i++)
	  {
      s << myTree.arrayOfItems[i] << " ";
    }
    if (myTree.numberOfItems > 0)
    {
    	s << myTree.arrayOfItems[myTree.numberOfItems];
  	}
  	return s;
	};
	
};

#endif
