/*
  Name:             Heap Sort Demonstration
  Author:           Balogh Zsolt & Pfaff Kroly
  EHA:              .ELTE
                    PFKIAAT.ELTE
*/


#include <iostream>
#include "CHeapTree.hpp"
#include "CSeqInFile.hpp"


using namespace std;

int main(int argc, char *argv[])
{

	int NUMBER_OF_ITEMS;
  CSeqInFile<int>* inputFile;
  CHeapTree<int>*  numbers;
  
  
  cout << endl << endl;
  cout << "  DEMONSTRATING HEAP SORT " << endl;
  cout << " -------------------------" << endl << endl << endl;
  
  
  string inputFileName;
  cout << endl << " filename:  ";
  cin  >> inputFileName;
  cout << endl << endl;
  
  inputFile = new CSeqInFile<int> (inputFileName);

  if(inputFile->fail())            // open fails
  {
    cerr << " ERROR: file not found!" << endl;
    return 2;
  }
  
  inputFile->first();
  NUMBER_OF_ITEMS=inputFile->current();
  
  while (NUMBER_OF_ITEMS!=0)
  {
	  numbers = new CHeapTree<int> (NUMBER_OF_ITEMS);
	  for (int i=0; i < NUMBER_OF_ITEMS && !inputFile->end(); i++)
	  {
	  	inputFile->next();
	    numbers->setItem(i, inputFile->current());
		}
		cout << " our array:\n ";
		for (int i=0; i < NUMBER_OF_ITEMS; i++)
		{
		  cout << numbers->getItem(i) << " ";
  	}
  	cout << endl;
		numbers->sortIt();
		cout << " our sorted array:\n ";
		for (int i=0; i < NUMBER_OF_ITEMS; i++)
		{
		  cout << numbers->getItem(i) << " ";
  	}
  	cout << endl;
		inputFile->first();
		NUMBER_OF_ITEMS=inputFile->current();
  }
  
  cout << "\n End of demonstrating...";
  char dummy;	
  cin >> dummy;
  
  delete numbers;
  delete inputFile;
  return 0;
  
}
